"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PUT = exports.POST = exports.PATCH = exports.OPTIONS = exports.HEAD = exports.GET = exports.DELETE = void 0;
var cookie_1 = __importDefault(require("cookie"));
var regexparam_1 = require("regexparam");
var undici_1 = require("undici");
var match = function (method, path, handler) {
    var _a = (0, regexparam_1.parse)(path), keys = _a.keys, pattern = _a.pattern;
    return (function (event, context) { return __awaiter(void 0, void 0, void 0, function () {
        var body, headers, httpMethod, isBase64Encoded, path, rawUrl, response;
        var _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    body = event.body, headers = event.headers, httpMethod = event.httpMethod, isBase64Encoded = event.isBase64Encoded, path = event.path, rawUrl = event.rawUrl;
                    if (![method].flat().includes(httpMethod)) {
                        return [2 /*return*/, { statusCode: 400 }];
                    }
                    if (!pattern.test(path)) {
                        return [2 /*return*/, { statusCode: 404 }];
                    }
                    return [4 /*yield*/, handler({
                            cookies: cookie_1.default.parse((_a = headers['cookie']) !== null && _a !== void 0 ? _a : ''),
                            fetch: undici_1.fetch,
                            getClientAddress: function () { return headers['x-nf-client-connection-ip']; },
                            params: ((_b = pattern.exec(path)) !== null && _b !== void 0 ? _b : [])
                                .slice(1, keys.length + 1)
                                .reduce(function (p, c, i) {
                                var _a;
                                return (__assign(__assign({}, p), (_a = {}, _a[keys[i]] = c, _a)));
                            }, {}),
                            platform: { context: context },
                            request: new undici_1.Request(rawUrl, {
                                body: ['GET', 'HEAD'].includes(httpMethod)
                                    ? null
                                    : typeof body === 'string'
                                        ? Buffer.from(body, isBase64Encoded ? 'base64' : 'utf-8')
                                        : body,
                                headers: new undici_1.Headers(headers),
                                method: httpMethod,
                            }),
                            url: new URL(rawUrl),
                        })];
                case 1:
                    response = _c.sent();
                    return [2 /*return*/, event.httpMethod === 'HEAD'
                            ? __assign(__assign({}, response), { body: undefined }) : response];
            }
        });
    }); });
};
var DELETE = function (path, handler) {
    return match(['DELETE'], path, handler);
};
exports.DELETE = DELETE;
var GET = function (path, handler) {
    return match(['GET', 'HEAD'], path, handler);
};
exports.GET = GET;
var HEAD = function (path, handler) {
    return match(['HEAD'], path, handler);
};
exports.HEAD = HEAD;
var OPTIONS = function (path, handler) {
    return match(['OPTIONS'], path, handler);
};
exports.OPTIONS = OPTIONS;
var PATCH = function (path, handler) {
    return match(['PATCH'], path, handler);
};
exports.PATCH = PATCH;
var POST = function (path, handler) {
    return match(['POST'], path, handler);
};
exports.POST = POST;
var PUT = function (path, handler) {
    return match(['PUT'], path, handler);
};
exports.PUT = PUT;
exports.default = match;
